function [pw, xK, yK, xg, yg, sigmap,sigma, sigmah, psi] = ODE_noJump(w, p ,par)

investment = par.investment; investmentD = par.investmentD;
Q = par.Q; AL=par.AL; AH=par.AH;  sigmaK=par.sigmaK; rho=par.rho; N=par.N; p_der_psi1_fitted = par.p_der_psi1_fitted;  p0=par.p0; d0=par.d0;  psi_w0=par.psi_w0;  p1=par.p1;

psi = max( min(  (investment(p) + rho*p  - AL)/(AH-AL),  1 ), 0 );
psi( w==0 ) = 0;   psi(w==1) = 1;  % Boundary condition
xK = (psi./w);  yK=(1-psi)./(1-w);
xg = zeros( numel(w) ,1);                yg=Q(w)./p./(1-w);

sigmap = sqrt( (AH-AL)./(p.*(xK-yK)) ) - sigmaK;
sigma = xK.*(sigmaK+sigmap);
sigmah = yK.*(sigmaK+sigmap);

pw =  max(0, sigmap./( w.*(1-w).*(xK-yK).*(sigmaK+sigmap) )) ;

% Deal with special cases at the boundaries
if (  ( numel(w)==1 && w==0 )  |  numel(w)>1 )    % Special case:  psi==0
    display( 'w=0 is evaluated in the ODE_noJump' );
    psi_w0 = (investmentD(p0) + rho)/ (AH-AL) * d0; 
    xK0 = psi_w0;  yK0 = 1;
    xg0 = 0;  yg0 = Q(0)/ p0;
    sigmap0 = 0;   sigmah0 = yK0*sigmaK; sigma0 = xK0*sigmaK;
    pw(w==0) = d0; xK(w==0)=xK0; yK(w==0)=yK0; xg(w==0)=xg0; yg(w==0)=yg0; sigmap(w==0) = sigmap0; sigma(w==0) = sigma0;  sigmah(w==0) = sigmah0;  psi(w==0)=0;
end
if (  ( numel(w)==1 && w==1 ) |   numel(w)>1  )  % Special case: psi==1
    xK(w==1) = 1;       yK(w==1)=0;  
    xg(w==1) = 0;                             yg(w==1) = 1/p1 * Q(0.9999)/( 1 - 0.9999 ); 
    pw(w==1) = ppval( p_der_psi1_fitted, 1 );    
end

% For other outputs
if( nargout >1 )
    index = (psi>=0.999);   % This function allows vector evaluation
    pw(index) = ppval( p_der_psi1_fitted, w(index) );  % for psi=1, we should directly use the derivative of the price function at psi=1
    sigmap(index) = pw(index).*w(index).*(1-w(index)).*(xK(index)-yK(index)) ./ (  1 -  pw(index).*w(index).*(1-w(index)).*(xK(index)-yK(index))  )  .* sigmaK;
    sigma(index) = xK(index).*(sigmaK+sigmap(index)  );
    sigmah(index) = yK(index).*(sigmaK+sigmap(index) );
end


